Bug 24348 - Klogd uses 100% cpu time if it comes across two NULLs in a log
Klogd uses 100% cpu time if it comes across two NULLs in a log
Status: CLOSED RAWHIDE
Product: Red Hat Linux
Classification: Retired
Component: sysklogd (Show other bugs)
7.0
All Linux
high Severity high
: ---
: ---
Assigned To: Bill Nottingham
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2001-01-19 06:17 EST by John Looney
Modified: 2014-03-16 22:18 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2001-01-19 07:46:34 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description John Looney 2001-01-19 06:17:47 EST
This problem affects me quite severely. This patch fixes the problem.
Please make this availible ASAP.

-------- Original Message --------
Subject: [PATCH] klogd busy loop on zero byte (output from 3c59x driver)
Date: Thu, 11 Jan 2001 09:48:57 +0100
From: "Troels Walsted Hansen" <troels@thule.no>
To: linux-kernel@vger.kernel.org, greg@wind.enjellic.com, joey@linux.de

Hi all.

I found a bug in the sysklogd package version 1.4. When it encounters a
zero
byte in the kernel logging output, the text parser enters a busy loop. I
came upon it when the 3c59x driver from kernel 2.4.0 started outputting two
zero bytes for the product code of my laptop's 3Com card. It could be
argued
that the kernel should never output zero bytes in the logging info, but
obviously that will happen from time to time.

I fear this bug might be considered a security issue as well, if the kernel
can be coerced to output a zero byte somehow, all kernel logging will stop.

I have included a patch to klogd.c to correct the issue.

--- sysklogd-1.4.orig/klogd.c   Mon Sep 18 09:34:11 2000
+++ sysklogd-1.4/klogd.c        Thu Jan 11 09:26:10 2001
@@ -739,6 +758,13 @@
                  break;  /* full line_buff or end of input buffer */
                 }

+               if( *ptr == '\0' ) /* zero byte */
+               {
+                  ptr++;       /* skip zero byte */
+                  space -= 1;
+                  len   -= 1;
+                  break;
+               }
                 if( *ptr == '\n' )  /* newline */
                 {
                    ptr++;      /* skip newline */

--
Troels Walsted Hansen
troels@thule.no
Comment 1 Harald Hoyer 2001-01-19 07:46:30 EST
reassigned to the correct package...
Comment 2 Bill Nottingham 2001-01-19 12:06:40 EST
Will be fixed in 1.4-5.
Comment 3 David Rees 2001-01-31 04:39:24 EST
Any idea when the updated sysklogd will be released?  With the release of kernel
2.4.1 a lot of 3c59x  driver users can be affected.  (At least I was!  ;-)  More
info is in these three threads on linux-kernel:
http://marc.theaimsgroup.com/?t=98086554600001&w=2&r=1
http://marc.theaimsgroup.com/?l=linux-kernel&m=98084989023325&w=2
http://marc.theaimsgroup.com/?l=linux-kernel&m=97920293924533&w=2
Comment 4 Bill Nottingham 2001-01-31 12:14:34 EST
It's available in rawhide currently.
Comment 5 David Rees 2001-01-31 12:16:34 EST
Thanks, I'll take a look and see if it fixes the problem I have in 2.4.1, if you
don't hear back from me it's because it works.  ;-)

Note You need to log in before you can comment on or make changes to this bug.